﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace SDKWebinarShippingExtensions
{
    [DataContract]
    public class Invoice
    {
        private string invoiceNumber;
        private string forCompany;
        private string address, city, state, zip;

        private decimal subtotal, shipping, tax, total;
        private InvoiceLineItem[] lineItems;

        [DataMember]
        public string InvoiceNumber
        {
            get { return invoiceNumber; }
            set { invoiceNumber = value; }
        }

        [DataMember]
        public string ForCompany
        {
            get { return forCompany; }
            set { forCompany = value; }
        }

        [DataMember]
        public string Address
        {
            get { return address; }
            set { address = value; }
        }

        [DataMember]
        public string City
        {
            get { return city; }
            set { city = value; }
        }

        [DataMember]
        public string State
        {
            get { return state; }
            set { state = value; }
        }

        [DataMember]
        public string Zip
        {
            get { return zip; }
            set { zip = value; }
        }

        [DataMember]
        public decimal Subtotal
        {
            get { return subtotal; }
            set { subtotal = value; }
        }

        [DataMember]
        public decimal Shipping
        {
            get { return shipping; }
            set { shipping = value; }
        }

        [DataMember]
        public decimal Tax
        {
            get { return tax; }
            set { tax = value; }
        }

        [DataMember]
        public decimal Total
        {
            get { return total; }
            set { total = value; }
        }

        [DataMember]
        public InvoiceLineItem[] LineItems
        {
            get { return lineItems; }
            set { lineItems = value; }
        }
    }

    [DataContract]
    public class InvoiceLineItem
    {
        private int qty;
        private decimal price;
        private string description;

        [DataMember]
        public int Qty
        {
            get { return qty; }
            set { qty = value; }
        }

        [DataMember]
        public decimal Price
        {
            get { return price; }
            set { price = value; }
        }

        [DataMember]
        public string Description
        {
            get { return description; }
            set { description = value; }
        }
    }
}
